package multex; //Jdk1_1CauseGetter.java

//History:
//2001-04-19  Knabe  Moved here from inner class Failure.Jdk1_1CauseGetter

/**Describes, how to get the causing exception of any exception in JDK 1.1
  with an accessible causing exception. For these few exceptions the causing
  exception is got by explicit call of the corresponding getter method, if
  such exists. The exceptions are java.lang.reflect.InvocationTargetException,
  ExceptionInInitializerError, java.sql.SQLWarning, java.sql.SQLException.

  @deprecated Since MulTEx 5: Preferably use the {@link ReflectionCauseGetter}, which
  is default since MulTEx 3e.
*/
public class Jdk1_1CauseGetter implements CauseGetter {
  public Throwable getCause(final Throwable i_throwable){
    if(i_throwable instanceof java.lang.reflect.InvocationTargetException){
      return ((java.lang.reflect.InvocationTargetException)i_throwable).getTargetException();
    }else if(i_throwable instanceof ExceptionInInitializerError){
      return ((ExceptionInInitializerError)i_throwable).getException();
    }else if(i_throwable instanceof java.sql.SQLWarning){ //MulTEx 3b: 2002-06-24 Knabe
      return ((java.sql.SQLWarning)i_throwable).getNextWarning();
    }else if(i_throwable instanceof java.sql.SQLException){ //1c: 2001-02-27 Knabe
      return ((java.sql.SQLException)i_throwable).getNextException();
/*JDK 1.2:
    }else if(i_throwable instanceof java.security.PrivilegedActionException){
      return ((java.security.PrivilegedActionException)i_throwable).getException();
    }else if(i_throwable instanceof java.awt.print.PrinterIOException){
      return ((java.awt.print.PrinterIOException)i_throwable).getIOException();
    }else if(i_throwable instanceof ClassNotFoundException){
      return ((ClassNotFoundException)i_throwable).getException();
*/
    }
    return null;
  }
}
